Index: pykota/trunk/bin/cupspykota
===================================================================
--- pykota/trunk/bin/cupspykota (revision 2398)
+++ pykota/trunk/bin/cupspykota (revision 2409)
@@ -775,26 +145,898 @@
                             if fullname.startswith('"') and fullname.endswith('"') :
                                 fullname = fullname[1:-1]
-                            print '%s cupspykota:%s "PyKota+%s" "PyKota managed %s"' % (devicetype, device, name, fullname)
+                            available.append('%s %s:%s "%s+%s" "%s managed %s"' \
+                                                 % (devicetype, self.myname, \
+                                                    device, self.MyName, \
+                                                    name, self.MyName, \
+                                                    fullname))
             os.remove(lockfilename)
-        retcode = 0                
+        available.append('direct %s:// "%s+Nothing" "%s managed Virtual Printer"' \
+                             % (self.myname, self.MyName, self.MyName))
+        return available
+                        
+    def initBackendParameters(self) :    
+        """Initializes the backend's attributes."""
+        # check that the DEVICE_URI environment variable's value is 
+        # prefixed with self.myname otherwise don't touch it.
+        # If this is the case, we have to remove the prefix from 
+        # the environment before launching the real backend 
+        self.logdebug("Initializing backend...")
+        muststartwith = "%s:" % self.myname
+        device_uri = os.environ.get("DEVICE_URI", "")
+        if device_uri.startswith(muststartwith) :
+            fulldevice_uri = device_uri[:]
+            device_uri = fulldevice_uri[len(muststartwith):]
+            for i in range(2) :
+                if device_uri.startswith("/") :  
+                    device_uri = device_uri[1:]
+        try :
+            (backend, destination) = device_uri.split(":", 1) 
+        except ValueError :    
+            if not device_uri :
+                self.logDebug("Not attached to an existing print queue.")
+                backend = ""
+                printerhostname = ""
+            else :    
+                raise PyKotaToolError, "Invalid DEVICE_URI : %s\n" % device_uri
+        else :        
+            while destination.startswith("/") :
+                destination = destination[1:]
+            checkauth = destination.split("@", 1)    
+            if len(checkauth) == 2 :
+                destination = checkauth[1]
+            printerhostname = destination.split("/")[0].split(":")[0]
+        
+        self.Action = "ALLOW"   # job allowed by default
+        self.JobId = sys.argv[1].strip()
+        # use CUPS' user when printing test pages from CUPS' web interface
+        self.UserName = sys.argv[2].strip() or pwd.getpwuid(os.geteuid())[0]
+        self.Title = sys.argv[3].strip()
+        self.Copies = int(sys.argv[4].strip())
+        self.Options = sys.argv[5].strip()
+        if len(sys.argv) == 7 :
+            self.InputFile = sys.argv[6] # read job's datas from file
+        else :    
+            self.InputFile = None        # read job's datas from stdin
+            
+        self.PrinterHostName = printerhostname    
+        self.RealBackend = backend
+        self.DeviceURI = device_uri
+        self.PrinterName = os.environ.get("PRINTER", "")
+        self.Directory = self.config.getPrinterDirectory(self.PrinterName)
+        self.DataFile = os.path.join(self.Directory, "%s-%s-%s-%s" % \
+                   (self.myname, self.PrinterName, self.UserName, self.JobId))
+        
+        (ippfilename, ippmessage) = self.parseIPPRequestFile()
+        self.ControlFile = ippfilename
+        john = ippmessage.operation_attributes.get("job-originating-host-name", \
+               ippmessage.job_attributes.get("job-originating-host-name", \
+               (None, None)))
+        if type(john) == type([]) : 
+            john = john[-1]
+        (chtype, self.ClientHost) = john 
+        jbing = ippmessage.job_attributes.get("job-billing", (None, None))
+        if type(jbing) == type([]) : 
+            jbing = jbing[-1]
+        (jbtype, self.JobBillingCode) = jbing
+        
+        self.logdebug("Backend : %s" % self.RealBackend)
+        self.logdebug("DeviceURI : %s" % self.DeviceURI)
+        self.logdebug("Printername : %s" % self.PrinterName)
+        self.logdebug("Username : %s" % self.UserName)
+        self.logdebug("JobId : %s" % self.JobId)
+        self.logdebug("Title : %s" % self.Title)
+        self.logdebug("Filename : %s" % self.InputFile)
+        self.logdebug("Copies : %s" % self.Copies)
+        self.logdebug("Options : %s" % self.Options)
+        self.logdebug("Directory : %s" % self.Directory) 
+        self.logdebug("DataFile : %s" % self.DataFile)
+        self.logdebug("ControlFile : %s" % self.ControlFile)
+        self.logdebug("JobBillingCode : %s" % self.JobBillingCode)
+        self.logdebug("JobOriginatingHostName : %s" % self.ClientHost)
+        
+        self.logdebug("Backend initialized.")
+        
+    def overwriteJobAttributes(self) :
+        """Overwrites some of the job's attributes if needed."""
+        self.logdebug("Sanitizing job's attributes...")
+        # First overwrite the job ticket
+        self.overwriteJobTicket()
+        
+        # do we want to strip out the Samba/Winbind domain name ?
+        separator = self.config.getWinbindSeparator()
+        if separator is not None :
+            self.UserName = self.UserName.split(separator)[-1]
+            
+        # do we want to lowercase usernames ?    
+        if self.config.getUserNameToLower() :
+            self.UserName = self.UserName.lower()
+            
+        # do we want to strip some prefix off of titles ?    
+        stripprefix = self.config.getStripTitle(self.PrinterName)
+        if stripprefix :
+            if fnmatch.fnmatch(self.Title[:len(stripprefix)], stripprefix) :
+                self.logdebug("Prefix [%s] removed from job's title [%s]." \
+                                      % (stripprefix, self.Title))
+                self.Title = self.Title[len(stripprefix):]
+                
+        self.logdebug("Username : %s" % self.UserName)
+        self.logdebug("BillingCode : %s" % self.JobBillingCode)
+        self.logdebug("Title : %s" % self.Title)
+        self.logdebug("Job's attributes sanitizing done.")
+                
+    def overwriteJobTicket(self) :    
+        """Should we overwrite the job's ticket (username and billingcode) ?"""
+        self.logdebug("Checking if we need to overwrite the job ticket...")
+        jobticketcommand = self.config.getOverwriteJobTicket(self.PrinterName)
+        if jobticketcommand is not None :
+            username = billingcode = action = None
+            self.logdebug("Launching subprocess [%s] to overwrite the job ticket." \
+                                     % jobticketcommand)
+            inputfile = os.popen(jobticketcommand, "r")
+            for line in inputfile.xreadlines() :
+                line = line.strip()
+                if line == "DENY" :
+                    self.logdebug("Seen DENY command.")
+                    action = "DENY"
+                elif line.startswith("USERNAME=") :    
+                    username = line.split("=", 1)[1].strip()
+                    self.logdebug("Seen new username [%s]" % username)
+                    action = None
+                elif line.startswith("BILLINGCODE=") :    
+                    billingcode = line.split("=", 1)[1].strip()
+                    self.logdebug("Seen new billing code [%s]" % billingcode)
+                    action = None
+            inputfile.close()    
+            
+            # now overwrite the job's ticket if new data was supplied
+            if action :
+                self.Action = action
+            if username :
+                self.UserName = username
+            # NB : we overwrite the billing code even if empty    
+            self.JobBillingCode = billingcode 
+        self.logdebug("Job ticket overwriting done.")
+            
+    def saveDatasAndCheckSum(self) :
+        """Saves the input datas into a static file."""
+        self.logdebug("Duplicating data stream into %s" % self.DataFile)
+        mustclose = 0
+        if self.InputFile is not None :
+            infile = open(self.InputFile, "rb")
+            mustclose = 1
+        else :    
+            infile = sys.stdin
+        CHUNK = 64*1024         # read 64 Kb at a time
+        dummy = 0
+        sizeread = 0
+        checksum = md5.new()
+        outfile = open(self.DataFile, "wb")    
+        while 1 :
+            data = infile.read(CHUNK) 
+            if not data :
+                break
+            sizeread += len(data)    
+            outfile.write(data)
+            checksum.update(data)    
+            if not (dummy % 32) : # Only display every 2 Mb
+                self.logdebug("%s bytes saved..." % sizeread)
+            dummy += 1    
+        outfile.close()
+        if mustclose :    
+            infile.close()
+            
+        self.JobSizeBytes = sizeread    
+        self.JobMD5Sum = checksum.hexdigest()
+        
+        self.logdebug("JobSizeBytes : %s" % self.JobSizeBytes)
+        self.logdebug("JobMD5Sum : %s" % self.JobMD5Sum)
+        self.logdebug("Data stream duplicated into %s" % self.DataFile)
+            
+    def clean(self) :
+        """Cleans up the place."""
+        self.logdebug("Cleaning up...")
+        self.deinstallSigTermHandler()
+        if not self.config.getPrinterKeepFiles(self.PrinterName) :
+            try :
+                self.logdebug("Work file %s will be deleted." % self.DataFile)
+            except AttributeError :    
+                pass
+            else :    
+                os.remove(self.DataFile)
+                self.logdebug("Work file %s has been deleted." % self.DataFile)
+        else :    
+            self.logdebug("Work file %s will be kept." % self.DataFile)
+        PyKotaTool.clean(self)    
+        self.logdebug("Clean.")
+            
+    def precomputeJobSize(self) :    
+        """Computes the job size with a software method."""
+        self.logdebug("Precomputing job's size...")
+        jobsize = 0
+        if self.JobSizeBytes :
+            try :
+                from pkpgpdls import analyzer, pdlparser
+            except ImportError :    
+                self.printInfo("pkpgcounter is now distributed separately, please grab it from http://www.librelogiciel.com/software/pkpgcounter/action_Download", "error")
+                self.printInfo("Precomputed job size will be forced to 0 pages.", "error")
+            else :     
+                infile = open(self.DataFile, "rb")
+                try :
+                    parser = analyzer.PDLAnalyzer(infile)
+                    jobsize = parser.getJobSize()
+                except pdlparser.PDLParserError, msg :    
+                    # Here we just log the failure, but
+                    # we finally ignore it and return 0 since this
+                    # computation is just an indication of what the
+                    # job's size MAY be.
+                    self.printInfo(_("Unable to precompute the job's size with the generic PDL analyzer : %s") % msg, "warn")
+                else :    
+                    if self.InputFile is not None :
+                        # when a filename is passed as an argument, the backend 
+                        # must generate the correct number of copies.
+                        jobsize *= self.Copies
+                infile.close()        
+        self.softwareJobSize = jobsize
+        self.logdebug("Precomputed job's size is %s pages." % self.softwareJobSize)
+        
+    def precomputeJobPrice(self) :    
+        """Precomputes the job price with a software method."""
+        self.logdebug("Precomputing job's price...")
+        self.softwareJobPrice = self.UserPQuota.computeJobPrice(self.softwareJobSize)
+        self.logdebug("Precomputed job's price is %.3f credits." \
+                                   % self.softwareJobPrice)
+        
+    def getCupsConfigDirectives(self, directives=[]) :
+        """Retrieves some CUPS directives from its configuration file.
+        
+           Returns a mapping with lowercased directives as keys and 
+           their setting as values.
+        """
+        self.logdebug("Parsing CUPS' configuration file...")
+        dirvalues = {} 
+        cupsroot = os.environ.get("CUPS_SERVERROOT", "/etc/cups")
+        cupsdconf = os.path.join(cupsroot, "cupsd.conf")
+        try :
+            conffile = open(cupsdconf, "r")
+        except IOError :    
+            raise PyKotaToolError, "Unable to open %s" % cupsdconf
+        else :    
+            for line in conffile.readlines() :
+                linecopy = line.strip().lower()
+                for di in [d.lower() for d in directives] :
+                    if linecopy.startswith("%s " % di) :
+                        try :
+                            val = line.split()[1]
+                        except :    
+                            pass # ignore errors, we take the last value in any case.
+                        else :    
+                            dirvalues[di] = val
+            conffile.close()            
+        self.logdebug("CUPS' configuration file parsed successfully.")
+        return dirvalues       
+            
+    def parseIPPRequestFile(self) :        
+        """Parses the IPP message file and returns a tuple (filename, parsedvalue)."""
+        self.logdebug("Parsing IPP request file...")
+        
+        class DummyClass :
+            operation_attributes = {}
+            job_attributes = {}
+            
+        ippmessage = DummyClass() # in case the code below fails
+        
+        self.regainPriv()
+        cupsdconf = self.getCupsConfigDirectives(["RequestRoot"])
+        requestroot = cupsdconf.get("requestroot", "/var/spool/cups")
+        if (len(self.JobId) < 5) and self.JobId.isdigit() :
+            ippmessagefile = "c%05i" % int(self.JobId)
+        else :    
+            ippmessagefile = "c%s" % self.JobId
+        ippmessagefile = os.path.join(requestroot, ippmessagefile)
+        try :
+            ippdatafile = open(ippmessagefile)
+        except :    
+            self.logdebug("Unable to open IPP request file %s" % ippmessagefile)
+        else :    
+            self.logdebug("Parsing of IPP request file %s begins." % ippmessagefile)
+            try :
+                ippmessage = IPPRequest(ippdatafile.read())
+                ippmessage.parse()
+            except IPPError, msg :    
+                self.printInfo("Error while parsing %s : %s" \
+                                      % (ippmessagefile, msg), "warn")
+            else :    
+                self.logdebug("Parsing of IPP request file %s ends." \
+                                       % ippmessagefile)
+            ippdatafile.close()
+        self.dropPriv()
+        self.logdebug("IPP request file parsed successfully.")
+        return (ippmessagefile, ippmessage)
+                
+    def exportJobInfo(self) :    
+        """Exports the actual job's attributes to the environment."""
+        self.logdebug("Exporting job information to the environment...")
+        os.environ["DEVICE_URI"] = self.DeviceURI       # WARNING !
+        os.environ["PYKOTAPRINTERNAME"] = self.PrinterName
+        os.environ["PYKOTADIRECTORY"] = self.Directory
+        os.environ["PYKOTADATAFILE"] = self.DataFile
+        os.environ["PYKOTAJOBSIZEBYTES"] = str(self.JobSizeBytes)
+        os.environ["PYKOTAMD5SUM"] = self.JobMD5Sum
+        os.environ["PYKOTAJOBORIGINATINGHOSTNAME"] = self.ClientHost or ""
+        os.environ["PYKOTAJOBID"] = self.JobId
+        os.environ["PYKOTAUSERNAME"] = self.UserName
+        os.environ["PYKOTATITLE"] = self.Title
+        os.environ["PYKOTACOPIES"] = str(self.Copies)
+        os.environ["PYKOTAOPTIONS"] = self.Options
+        os.environ["PYKOTAFILENAME"] = self.InputFile or ""
+        os.environ["PYKOTAJOBBILLING"] = self.JobBillingCode or ""
+        os.environ["PYKOTACONTROLFILE"] = self.ControlFile
+        os.environ["PYKOTAPRINTERHOSTNAME"] = self.PrinterHostName
+        os.environ["PYKOTAPRECOMPUTEDJOBSIZE"] = str(self.softwareJobSize)
+        self.logdebug("Environment updated.")
+        
+    def exportUserInfo(self) :
+        """Exports user information to the environment."""
+        self.logdebug("Exporting user information to the environment...")
+        os.environ["PYKOTAOVERCHARGE"] = str(self.User.OverCharge)
+        os.environ["PYKOTALIMITBY"] = str(self.User.LimitBy)
+        os.environ["PYKOTABALANCE"] = str(self.User.AccountBalance or 0.0)
+        os.environ["PYKOTALIFETIMEPAID"] = str(self.User.LifeTimePaid or 0.0)
+        
+        os.environ["PYKOTAPAGECOUNTER"] = str(self.UserPQuota.PageCounter or 0)
+        os.environ["PYKOTALIFEPAGECOUNTER"] = str(self.UserPQuota.LifePageCounter or 0)
+        os.environ["PYKOTASOFTLIMIT"] = str(self.UserPQuota.SoftLimit)
+        os.environ["PYKOTAHARDLIMIT"] = str(self.UserPQuota.HardLimit)
+        os.environ["PYKOTADATELIMIT"] = str(self.UserPQuota.DateLimit)
+        os.environ["PYKOTAWARNCOUNT"] = str(self.UserPQuota.WarnCount)
+        
+        # TODO : move this elsewhere once software accounting is done only once.
+        os.environ["PYKOTAPRECOMPUTEDJOBPRICE"] = str(self.softwareJobPrice)
+        
+        self.logdebug("Environment updated.")
+        
+    def exportPrinterInfo(self) :
+        """Exports printer information to the environment."""
+        self.logdebug("Exporting printer information to the environment...")
+        # exports the list of printers groups the current
+        # printer is a member of
+        os.environ["PYKOTAPGROUPS"] = ",".join([p.Name for p in self.storage.getParentPrinters(self.Printer)])
+        self.logdebug("Environment updated.")
+        
+    def exportPhaseInfo(self, phase) :
+        """Exports phase information to the environment."""
+        self.logdebug("Exporting phase information [%s] to the environment..." % phase)
+        os.environ["PYKOTAPHASE"] = phase
+        self.logdebug("Environment updated.")
+        
+    def exportJobSizeAndPrice(self) :
+        """Exports job's size and price information to the environment."""
+        self.logdebug("Exporting job's size and price information to the environment...")
+        os.environ["PYKOTAJOBSIZE"] = str(self.JobSize)
+        os.environ["PYKOTAJOBPRICE"] = str(self.JobPrice)
+        self.logdebug("Environment updated.")
+        
+    def acceptJob(self) :        
+        """Returns the appropriate exit code to tell CUPS all is OK."""
+        return 0
+            
+    def removeJob(self) :            
+        """Returns the appropriate exit code to let CUPS think all is OK.
+        
+           Returning 0 (success) prevents CUPS from stopping the print queue.
+        """   
+        return 0
+        
+    def launchPreHook(self) :
+        """Allows plugging of an external hook before the job gets printed."""
+        prehook = self.config.getPreHook(self.PrinterName)
+        if prehook :
+            self.logdebug("Executing pre-hook [%s]..." % prehook)
+            retcode = os.system(prehook)
+            self.logdebug("pre-hook exited with status %s." % retcode)
+        
+    def launchPostHook(self) :
+        """Allows plugging of an external hook after the job gets printed and/or denied."""
+        posthook = self.config.getPostHook(self.PrinterName)
+        if posthook :
+            self.logdebug("Executing post-hook [%s]..." % posthook)
+            retcode = os.system(posthook)
+            self.logdebug("post-hook exited with status %s." % retcode)
+            
+    def improveMessage(self, message) :        
+        """Improves a message by adding more informations in it if possible."""
+        try :
+            return "%s@%s(%s) => %s" % (self.UserName, \
+                                        self.PrinterName, \
+                                        self.JobId, \
+                                        message)
+        except :                                               
+            return message
+        
+    def logdebug(self, message) :        
+        """Improves the debug message before outputting it."""
+        PyKotaTool.logdebug(self, self.improveMessage(message))
+        
+    def printInfo(self, message, level="info") :        
+        """Improves the informational message before outputting it."""
+        self.logger.log_message(self.improveMessage(message), level)
+    
+    def startingBanner(self) :
+        """Retrieves a starting banner for current printer and returns its content."""
+        self.logdebug("Retrieving starting banner...")
+        self.printBanner(self.config.getStartingBanner(self.PrinterName))
+        self.logdebug("Starting banner retrieved.")
+    
+    def endingBanner(self) :
+        """Retrieves an ending banner for current printer and returns its content."""
+        self.logdebug("Retrieving ending banner...")
+        self.printBanner(self.config.getEndingBanner(self.PrinterName))
+        self.logdebug("Ending banner retrieved.")
+        
+    def printBanner(self, bannerfileorcommand) :
+        """Reads a banner or generates one through an external command.
+        
+           Returns the banner's content in a format which MUST be accepted
+           by the printer.
+        """
+        self.logdebug("Printing banner...")
+        if bannerfileorcommand :
+            if os.access(bannerfileorcommand, os.X_OK) or \
+                  not os.path.isfile(bannerfileorcommand) :
+                self.logdebug("Launching %s to generate a banner." % bannerfileorcommand)
+                child = popen2.Popen3(bannerfileorcommand, capturestderr=1)
+                self.runOriginalBackend(child.fromchild, isBanner=1)
+                child.tochild.close()
+                child.childerr.close()
+                child.fromchild.close()
+                status = child.wait()
+                if os.WIFEXITED(status) :
+                    status = os.WEXITSTATUS(status)
+                self.printInfo(_("Banner generator %s exit code is %s") \
+                                         % (bannerfileorcommand, str(status)))
+            else :
+                self.logdebug("Using %s as the banner." % bannerfileorcommand)
+                try :
+                    fh = open(bannerfileorcommand, 'rb')
+                except IOError, msg :    
+                    self.printInfo("Impossible to open %s : %s" \
+                                       % (bannerfileorcommand, msg), "error")
+                else :    
+                    self.runOriginalBackend(fh, isBanner=1)
+                    fh.close()
+        self.logdebug("Banner printed...")
+                
+    def handleBanner(self, bannertype, withaccounting) :
+        """Handles the banner with or without accounting."""
+        if withaccounting :
+            acc = "with"
+        else :    
+            acc = "without"
+        self.logdebug("Handling %s banner %s accounting..." % (bannertype, acc))
+        if (self.Action == 'DENY') and \
+           (self.UserPQuota.WarnCount >= \
+                            self.config.getMaxDenyBanners(self.PrinterName)) :
+            self.printInfo(_("Banner won't be printed : maximum number of deny banners reached."), \
+                             "warn")
+        else :
+            if self.Action == 'DENY' :
+                self.logdebug("Incrementing the number of deny banners for user %s on printer %s" \
+                                  % (self.UserName, self.PrinterName))
+                self.UserPQuota.incDenyBannerCounter() # increments the warning counter
+                self.exportUserInfo()
+            getattr(self, "%sBanner" % bannertype)()
+            if withaccounting :
+                if self.accounter.isSoftware :
+                    self.BannerSize += 1 # TODO : fix this by passing the banner's content through software accounting
+        self.logdebug("%s banner done." % bannertype.title())
+        
+    def sanitizeJobSize(self) :    
+        """Sanitizes the job's size if needed."""
+        # TODO : there's a difficult to see bug here when banner accounting is activated and hardware accounting is used.
+        self.logdebug("Sanitizing job's size...")
+        if self.softwareJobSize and (self.JobSize != self.softwareJobSize) :
+            self.printInfo(_("Beware : computed job size (%s) != precomputed job size (%s)") % \
+                                       (self.JobSize, self.softwareJobSize), \
+                           "error")
+            (limit, replacement) = self.config.getTrustJobSize(self.PrinterName)
+            if limit is None :
+                self.printInfo(_("The job size will be trusted anyway according to the 'trustjobsize' directive"), "warn")
+            else :
+                if self.JobSize <= limit :
+                    self.printInfo(_("The job size will be trusted because it is inferior to the 'trustjobsize' directive's limit %s") % limit, "warn")
+                else :
+                    self.printInfo(_("The job size will be modified according to the 'trustjobsize' directive : %s") % replacement, "warn")
+                    if replacement == "PRECOMPUTED" :
+                        self.JobSize = self.softwareJobSize
+                    else :    
+                        self.JobSize = replacement
+        self.logdebug("Job's size sanitized.")
+                        
+    def getPrinterUserAndUserPQuota(self) :        
+        """Returns a tuple (policy, printer, user, and user print quota) on this printer.
+        
+           "OK" is returned in the policy if both printer, user and user print quota
+           exist in the Quota Storage.
+           Otherwise, the policy as defined for this printer in pykota.conf is returned.
+           
+           If policy was set to "EXTERNAL" and one of printer, user, or user print quota
+           doesn't exist in the Quota Storage, then an external command is launched, as
+           defined in the external policy for this printer in pykota.conf
+           This external command can do anything, like automatically adding printers
+           or users, for example, and finally extracting printer, user and user print
+           quota from the Quota Storage is tried a second time.
+           
+           "EXTERNALERROR" is returned in case policy was "EXTERNAL" and an error status
+           was returned by the external command.
+        """
+        self.logdebug("Retrieving printer, user, and user print quota entry from database...")
+        for passnumber in range(1, 3) :
+            printer = self.storage.getPrinter(self.PrinterName)
+            user = self.storage.getUser(self.UserName)
+            userpquota = self.storage.getUserPQuota(user, printer)
+            if printer.Exists and user.Exists and userpquota.Exists :
+                policy = "OK"
+                break
+            (policy, args) = self.config.getPrinterPolicy(self.PrinterName)
+            if policy == "EXTERNAL" :    
+                commandline = self.formatCommandLine(args, user, printer)
+                if not printer.Exists :
+                    self.printInfo(_("Printer %s not registered in the PyKota system, applying external policy (%s) for printer %s") % (self.PrinterName, commandline, self.PrinterName))
+                if not user.Exists :
+                    self.printInfo(_("User %s not registered in the PyKota system, applying external policy (%s) for printer %s") % (self.UserName, commandline, self.PrinterName))
+                if not userpquota.Exists :
+                    self.printInfo(_("User %s doesn't have quota on printer %s in the PyKota system, applying external policy (%s) for printer %s") % (self.UserName, self.PrinterName, commandline, self.PrinterName))
+                if os.system(commandline) :
+                    self.printInfo(_("External policy %s for printer %s produced an error. Job rejected. Please check PyKota's configuration files.") % (commandline, self.PrinterName), "error")
+                    policy = "EXTERNALERROR"
+                    break
+            else :        
+                if not printer.Exists :
+                    self.printInfo(_("Printer %s not registered in the PyKota system, applying default policy (%s)") % (self.PrinterName, policy))
+                if not user.Exists :
+                    self.printInfo(_("User %s not registered in the PyKota system, applying default policy (%s) for printer %s") % (self.UserName, policy, self.PrinterName))
+                if not userpquota.Exists :
+                    self.printInfo(_("User %s doesn't have quota on printer %s in the PyKota system, applying default policy (%s)") % (self.UserName, self.PrinterName, policy))
+                break
+                
+        if policy == "EXTERNAL" :    
+            if not printer.Exists :
+                self.printInfo(_("Printer %s still not registered in the PyKota system, job will be rejected") % self.PrinterName)
+            if not user.Exists :
+                self.printInfo(_("User %s still not registered in the PyKota system, job will be rejected on printer %s") % (self.UserName, self.PrinterName))
+            if not userpquota.Exists :
+                self.printInfo(_("User %s still doesn't have quota on printer %s in the PyKota system, job will be rejected") % (self.UserName, self.PrinterName))
+        self.Policy = policy         
+        self.Printer = printer
+        self.User = user
+        self.UserPQuota = userpquota
+        self.logdebug("Retrieval of printer, user and user print quota entry done.")
+        
+    def getBillingCode(self) :    
+        """Extracts the billing code from the database.
+         
+           An optional script is launched to notify the user when
+           the billing code is unknown and PyKota was configured to
+           deny printing in this case.
+        """
+        self.logdebug("Retrieving billing code information from the database...")
+        self.BillingCode = None
+        if self.JobBillingCode :
+            self.BillingCode = self.storage.getBillingCode(self.JobBillingCode)
+            if self.BillingCode.Exists :
+                self.logdebug("Billing code [%s] found in database." % self.JobBillingCode)
+            else :
+                msg = "Unknown billing code [%s] : " % self.JobBillingCode
+                (newaction, script) = self.config.getUnknownBillingCode(self.PrinterName)
+                if newaction == "CREATE" :
+                    self.logdebug(msg + "will be created.")
+                    self.BillingCode = self.storage.addBillingCode(self.JobBillingCode)
+                    if self.BillingCode.Exists :
+                        self.logdebug(msg + "has been created.")
+                    else :    
+                        self.printInfo(msg + "couldn't be created.", "error")
+                else :    
+                    self.logdebug(msg + "job will be denied.")
+                    self.Action = newaction
+                    if script is not None : 
+                        self.logdebug(msg + "launching subprocess [%s] to notify user." % script)
+                        os.system(script)
+        self.logdebug("Retrieval of billing code information done.")
+        
+    def checkIfDupe(self) :    
+        """Checks if the job is a dupe, and handles the situation."""
+        self.logdebug("Checking if the job is a dupe...")
+        denyduplicates = self.config.getDenyDuplicates(self.PrinterName)
+        if not denyduplicates :
+            self.logdebug("We don't care about dupes after all.")
+        elif self.Printer.LastJob.Exists \
+             and (self.Printer.LastJob.UserName == self.UserName) \
+             and (self.Printer.LastJob.JobMD5Sum == self.JobMD5Sum) :
+            # TODO : use the current user's last job instead of  
+            # TODO : the current printer's last job. This would be
+            # TODO : better but requires an additional database query
+            # TODO : with SQL, and is much more complex with the 
+            # TODO : actual LDAP schema. Maybe this is not very
+            # TODO : important, because usually dupes are rapidly sucessive.
+            msg = _("Job is a dupe")
+            if denyduplicates == 1 :
+                self.printInfo("%s : %s." % (msg, _("Printing is denied by configuration")), "warn")
+                self.Action = "DENY"
+            else :    
+                self.logdebug("Launching subprocess [%s] to see if dupes should be allowed or not." % denyduplicates)
+                fanswer = os.popen(denyduplicates, "r")
+                self.Action = fanswer.read().strip().upper()
+                fanswer.close()
+                if self.Action == "DENY" :     
+                    self.printInfo("%s : %s." % (msg, _("Subprocess denied printing of a dupe")), "warn")
+                else :    
+                    self.printInfo("%s : %s." % (msg, _("Subprocess allowed printing of a dupe")), "warn")
+        else :            
+            self.logdebug("Job doesn't seem to be a dupe.")
+        self.logdebug("Checking if the job is a dupe done.")
+        
+    def mainWork(self) :    
+        """Main work is done here."""
+        if not self.JobSizeBytes :
+            # if no data to pass to real backend, probably a filter
+            # higher in the chain failed because of a misconfiguration.
+            # we deny the job in this case (nothing to print anyway)
+            self.printInfo(_("Job contains no data. Printing is denied."), "error")
+            return self.removeJob()
+            
+        self.getPrinterUserAndUserPQuota()
+        if self.Policy == "EXTERNALERROR" :
+            # Policy was 'EXTERNAL' and the external command returned an error code
+            return self.removeJob()
+        elif self.Policy == "EXTERNAL" :
+            # Policy was 'EXTERNAL' and the external command wasn't able
+            # to add either the printer, user or user print quota
+            return self.removeJob()
+        elif self.Policy == "DENY" :    
+            # Either printer, user or user print quota doesn't exist,
+            # and the job should be rejected.
+            return self.removeJob()
+        elif self.Policy == "ALLOW" :
+            # ALLOW means : Either printer, user or user print quota doesn't exist,
+            #               but the job should be allowed anyway.
+            self.printInfo(_("Job allowed by printer policy. No accounting will be done."), "warn")
+            return self.printJobDatas()
+        elif self.Policy == "OK" :
+            # OK means : Both printer, user and user print quota exist, job should
+            #            be allowed if current user is allowed to print on this printer
+            return self.doWork()
+        else :    
+            self.printInfo(_("Invalid policy %s for printer %s") % (self.Policy, self.PrinterName), "error")
+            return self.removeJob()
+    
+    def doWork(self) :    
+        """The accounting work is done here."""
+        self.precomputeJobPrice()
+        self.exportUserInfo()
+        self.exportPrinterInfo()
+        self.exportPhaseInfo("BEFORE")
+        
+        if self.Action != "DENY" :
+            # If printing is still allowed at this time, we
+            # need to extract the billing code information from the database.
+            # No need to do this if the job is denied, this way we
+            # save some database queries.
+            self.getBillingCode()
+            
+        if self.Action != "DENY" :
+            # If printing is still allowed at this time, we
+            # need to check if the job is a dupe or not, and what to do then.
+            # No need to do this if the job is denied, this way we
+            # save some database queries.
+            self.checkIfDupe()
+                    
+        if self.Action != "DENY" :
+            # If printing is still allowed at this time, we
+            # need to check the user's print quota on the current printer.
+            # No need to do this if the job is denied, this way we
+            # save some database queries.
+            self.logdebug("Checking user %s print quota entry on printer %s" \
+                                    % (self.UserName, self.PrinterName))
+            self.Action = self.warnUserPQuota(self.UserPQuota)
+            
+        # exports some new environment variables
+        os.environ["PYKOTAACTION"] = str(self.Action)
+        
+        # launches the pre hook
+        self.launchPreHook()
+        
+        # handle starting banner pages without accounting
+        self.BannerSize = 0
+        accountbanner = self.config.getAccountBanner(self.PrinterName)
+        if accountbanner in ["ENDING", "NONE"] :
+            self.handleBanner("starting", 0)
+        
+        if self.Action == "DENY" :
+            self.printInfo(_("Job denied, no accounting will be done."))
+        else :
+            self.printInfo(_("Job accounting begins."))
+            self.deinstallSigTermHandler()
+            self.accounter.beginJob(self.Printer)
+            self.installSigTermHandler()
+        
+        # handle starting banner pages with accounting
+        if accountbanner in ["STARTING", "BOTH"] :
+            if not self.gotSigTerm :
+                self.handleBanner("starting", 1)
+        
+        # pass the job's data to the real backend    
+        if (not self.gotSigTerm) and (self.Action in ["ALLOW", "WARN"]) :
+            retcode = self.printJobDatas()
+        else :        
+            retcode = self.removeJob()
+        
+        # indicate phase change
+        self.exportPhaseInfo("AFTER")
+        
+        # handle ending banner pages with accounting
+        if accountbanner in ["ENDING", "BOTH"] :
+            if not self.gotSigTerm :
+                self.handleBanner("ending", 1)
+        
+        # stops accounting
+        if self.Action == "DENY" :
+            self.printInfo(_("Job denied, no accounting has been done."))
+        else :
+            self.deinstallSigTermHandler()
+            self.accounter.endJob(self.Printer)
+            self.installSigTermHandler()
+            self.printInfo(_("Job accounting ends."))
+        
+        # Do all these database changes within a single transaction    
+        # NB : we don't enclose ALL the changes within a single transaction
+        # because while waiting for the printer to answer its internal page
+        # counter, we would open the door to accounting problems for other
+        # jobs launched by the same user at the same time on other printers.
+        # All the code below doesn't take much time, so it's fine.
+        self.storage.beginTransaction()
+        try :
+            # retrieve the job size    
+            if self.Action == "DENY" :
+                self.JobSize = 0
+                self.printInfo(_("Job size forced to 0 because printing is denied."))
+            else :    
+                self.UserPQuota.resetDenyBannerCounter()
+                self.JobSize = self.accounter.getJobSize(self.Printer)
+                self.sanitizeJobSize()
+                self.JobSize += self.BannerSize
+            self.printInfo(_("Job size : %i") % self.JobSize)
+            
+            # update the quota for the current user on this printer 
+            self.printInfo(_("Updating user %s's quota on printer %s") % (self.UserName, self.PrinterName))
+            self.JobPrice = self.UserPQuota.increasePagesUsage(self.JobSize)
+            
+            # adds the current job to history    
+            self.Printer.addJobToHistory(self.JobId, self.User, self.accounter.getLastPageCounter(), \
+                                    self.Action, self.JobSize, self.JobPrice, self.InputFile, \
+                                    self.Title, self.Copies, self.Options, self.ClientHost, \
+                                    self.JobSizeBytes, self.JobMD5Sum, None, self.JobBillingCode)
+            self.printInfo(_("Job added to history."))
+            
+            if self.BillingCode and self.BillingCode.Exists :
+                self.BillingCode.consume(self.JobSize, self.JobPrice)
+                self.printInfo(_("Billing code %s was updated.") % self.BillingCode.BillingCode)
+        except :    
+            self.storage.rollbackTransaction()
+            raise
+        else :    
+            self.storage.commitTransaction()
+            
+        # exports some new environment variables
+        self.exportJobSizeAndPrice()
+        
+        # then re-export user information with new values
+        self.exportUserInfo()
+        
+        # handle ending banner pages without accounting
+        if accountbanner in ["STARTING", "NONE"] :
+            self.handleBanner("ending", 0)
+                    
+        self.launchPostHook()
+            
+        return retcode    
+               
+    def printJobDatas(self) :           
+        """Sends the job's datas to the real backend."""
+        self.logdebug("Sending job's datas to real backend...")
+        if self.InputFile is None :
+            infile = open(self.DataFile, "rb")
+        else :    
+            infile = None
+        self.runOriginalBackend(infile)
+        if self.InputFile is None :
+            infile.close()
+        self.logdebug("Job's datas sent to real backend.")
+        
+    def runOriginalBackend(self, filehandle=None, isBanner=0) :
+        """Launches the original backend."""
+        originalbackend = os.path.join(os.path.split(sys.argv[0])[0], self.RealBackend)
+        if not isBanner :
+            arguments = [os.environ["DEVICE_URI"]] + sys.argv[1:]
+        else :    
+            # For banners, we absolutely WANT
+            # to remove any filename from the command line !
+            self.logdebug("It looks like we try to print a banner.")
+            arguments = [os.environ["DEVICE_URI"]] + sys.argv[1:6]
+        arguments[2] = self.UserName # in case it was overwritten by external script
+        # TODO : do something about job-billing option, in case it was overwritten as well...
+        
+        self.logdebug("Starting original backend %s with args %s" % (originalbackend, " ".join(['"%s"' % a for a in arguments])))
+        self.regainPriv()    
+        pid = os.fork()
+        self.logdebug("Forked !")
+        if pid == 0 :
+            if filehandle is not None :
+                self.logdebug("Redirecting file handle to real backend's stdin")
+                os.dup2(filehandle.fileno(), 0)
+            try :
+                self.logdebug("Calling execve...")
+                os.execve(originalbackend, arguments, os.environ)
+            except OSError, msg :
+                self.logdebug("execve() failed: %s" % msg)
+            self.logdebug("We shouldn't be there !!!")    
+            os._exit(-1)
+        self.dropPriv()    
+        
+        killed = 0
+        status = -1
+        while status == -1 :
+            try :
+                status = os.waitpid(pid, 0)[1]
+            except OSError, (err, msg) :
+                if (err == 4) and self.gotSigTerm :
+                    os.kill(pid, signal.SIGTERM)
+                    killed = 1
+                    
+        if os.WIFEXITED(status) :
+            status = os.WEXITSTATUS(status)
+            if status :
+                level = "error"
+            else :    
+                level = "info"
+            self.printInfo("CUPS backend %s returned %d." % \
+                                     (originalbackend, status), level)
+            return status
+        elif not killed :
+            self.printInfo("CUPS backend %s died abnormally." % \
+                               originalbackend, "error")
+            return -1
+        else :
+            self.printInfo("CUPS backend %s was killed." % \
+                               originalbackend, "warn")
+            return 1
+        
+if __name__ == "__main__" :    
+    # This is a CUPS backend, we should act and die like a CUPS backend
+    wrapper = CUPSBackend()
+    if len(sys.argv) == 1 :
+        print "\n".join(wrapper.discoverOtherBackends())
+        sys.exit(0)                
     elif len(sys.argv) not in (6, 7) :    
-        sys.stderr.write("ERROR: %s job-id user title copies options [file]\n" % sys.argv[0])
-        retcode = 1
+        sys.stderr.write("ERROR: %s job-id user title copies options [file]\n"\
+                              % sys.argv[0])
+        sys.exit(1)
     else :    
         try :
-            # Initializes the backend
-            kotabackend = PyKotaBackend()    
-            kotabackend.deferredInit()
-            retcode = kotabackend.mainWork()
-            kotabackend.storage.close()
-            kotabackend.closeJobDataStream()    
-        except SystemExit :    
-            retcode = -1
-        except :
+            wrapper.deferredInit()
+            wrapper.initBackendParameters()
+            wrapper.saveDatasAndCheckSum()
+            wrapper.accounter = openAccounter(wrapper)
+            wrapper.precomputeJobSize()
+            wrapper.overwriteJobAttributes()
+            wrapper.exportJobInfo()
+            retcode = wrapper.mainWork()
+        except SystemExit, e :    
+            retcode = e.code
+        except :    
             try :
-                kotabackend.crashed("cupspykota backend failed")
+                wrapper.crashed("cupspykota backend failed")
             except :    
                 crashed("cupspykota backend failed")
-            retcode = 1    
-        
-    sys.exit(retcode)    
+            retcode = 1
+        wrapper.clean()
+        sys.exit(retcode)
